function plot_axes(init_param,LW,eucl)

%
% PLOT_AXES plots 2D or 3D principal curves data on the current figure.
%
% USE:
% plot_axes(init_param,line_width,euclidean)
%
%    init_param = structure with initialization parameters (as given by initialize_SPCA_2.m)
%
%    line_width = line width of the curves on the plot
%
%    euclidean = 1 (draws principal curves with Euclidean metric)
%                0 (draws first principal curve with the metric selected in the initialization parameters)
%
% First, second and third axes are plotted in red, green and blue.
%

if exist('LW')
else
    LW=0.1;
end

if exist('eucl')
else
    eucl=0;
end

color = 'rkb';

if eucl == 1
    for n=1:size(init_param.Aref,1)
        eje = init_param.eucl_PCs(n).eje;
        plotea_eje(eje,[color(n) 'o-'],LW)
    end
else
    eje = init_param.PC;
    plotea_eje(eje,[color(1) 'o-'],LW)
end




