

function eje_mod = modifica_axis(dat,eje,pto_origen,ptos,Nbins,Aref,principal,Nv,criterio)

% USO:
% eje_mod =
% modifica_axis(dat,eje,pto_origen,ptos,Nbins,Aref,principal,Nv,criterio)
%
% criterio:
% 1 = los incrementos locales de r son equivalentes a incrementos locales de x (no varia el Jacobiano)
% 2 = p (los incrementos de r son equivalentes a incrementos de p en X)
% 3 = p^(1/3) (los incrementos de r son equivalentes a incrementos de p^(1/3) en X)
%

if criterio ==1
    eje_mod = eje;
    
elseif (criterio == 2 | criterio == 3)
    pto_proximo = zeros(size(ptos));
    resp = zeros(1,size(ptos,2));

    for n=1:size(ptos,2)
        [pto_proximo(:,n),resp(:,n)] = punto_en_eje_NLPCA(ptos(:,n),eje);
    end

     aux1 = max([(max(resp)-min(resp)) 0.00000001]);
     
     saltos_pos = abs((max([0 resp])-max([0 min(resp)]))/aux1);
     saltos_neg = abs((min([0 resp])-min([0 max(resp)]))/aux1);

    R = linspace(min([0 resp])-1,0,round(max([3 sqrt(size(ptos,2))*saltos_neg])));
    deltaR = R(2)-R(1);
    lala=[ R linspace( min([deltaR max([0 resp])/3]),max([0 resp])+1,max([3 sqrt(size(ptos,2))*saltos_pos]) ) ];
    %length(lala)
    R = monotono2(lala);

    [H] = histc(resp,R);

    if criterio == 2
        prob = H(1:end-1)./diff(R)*(1/(sum(H)));
    elseif criterio == 3
         aux = H(1:end-1)./diff(R)*(1/(sum(H)));
         prob = aux.^(1/3);
    end
   
    bin_central = find(R==0);
    Cpos = cumsum(prob(bin_central:end).*diff(R(bin_central:end)));
    Cneg = cumsum(prob(bin_central-1:-1:1).*abs(diff(R(bin_central:-1:1))));

    if principal == 1
        Npos = round(Nbins*Cpos(end)/(Cpos(end)+Cneg(end)));
        Nneg = round(Nbins*Cneg(end)/(Cpos(end)+Cneg(end)));
    else
        Npos = round(Nbins/2);
        Nneg = round(Nbins/2);
    end

    dat_pos = linspace(0,Cpos(end),Npos);
    ind_ori_pos = interp1(monotono2([0 Cpos]),R(bin_central:end),dat_pos,'linear','extrap');

    dat_neg = linspace(0,Cneg(end),Nneg);
    ind_ori_neg = interp1(monotono2([0 Cneg]),R(bin_central:-1:1),dat_neg,'linear','extrap');

    %%%%%%%%

    DIM = size(ptos,1);
    pto_proximo = pto_origen;

    %%%%%%%%%%%%%%%%%%%%%%%%

    for n=1:size(ind_ori_pos,2)
        n1 = find(cat(1,eje(:).ref) == fix(ind_ori_pos(n)));
        n2 = find(cat(1,eje(:).ref) == sign(ind_ori_pos(n))+ fix(ind_ori_pos(n)));

        if isempty(n1),
            n1 = find(cat(1,eje(:).ref) == max(cat(1,eje(:).ref)));
        end

        pto1 = eje(n1(1)).pto;
        if isempty(n2), pto2 = pto1;else pto2 = eje(n2(1)).pto;end
        vect21 = pto2-pto1;
        dec = abs(ind_ori_pos(n)-fix(ind_ori_pos(n)));
        pto_proximo_pos(:,n) = pto1 + dec*vect21;
    end

    %%%%%%%%%%%%%%%%%%%%

    for n=1:size(ind_ori_neg,2)
        n1 = find(cat(1,eje(:).ref) == fix(ind_ori_neg(n)));
        n2 = find(cat(1,eje(:).ref) == sign(ind_ori_neg(n))+ fix(ind_ori_neg(n)));

        if isempty(n1),
            n1 = find(cat(1,eje(:).ref) == min(cat(1,eje(:).ref)));
        end

        pto1 = eje(n1(1)).pto;
        if isempty(n2), pto2 = pto1;else pto2 = eje(n2(1)).pto;end
        vect21 = pto2-pto1;
        dec = abs(ind_ori_neg(n)-fix(ind_ori_neg(n)));
        pto_proximo_neg(:,n) = pto1 + dec*vect21;
    end

    %%%%%%%%%%%%%%%%%%%%

    aux_pto = [pto_proximo_pos pto_proximo_neg];
    aux_ref = [0:size(pto_proximo_pos,2)-1 0:-1:-size(pto_proximo_neg,2)+1];
    AAref = Aref;
    for n=1:size(pto_proximo_pos,2)
        eje_mod(n).pto = aux_pto(:,n);
        eje_mod(n).ref = aux_ref(:,n);

        V3 = pca_en_point(dat,aux_pto(:,n),Nv);
        AAref = alinea_bases(V3,AAref,1);
        eje_mod(n).V_der = AAref;
    end
    AAref = Aref;
    for n = size(pto_proximo_pos,2)+1:size(pto_proximo_pos,2)+size(pto_proximo_neg,2)
        eje_mod(n).pto = aux_pto(:,n);
        eje_mod(n).ref = aux_ref(:,n);

        V3 = pca_en_point(dat,aux_pto(:,n),Nv);
        AAref = alinea_bases(V3,AAref,1);
        eje_mod(n).V_der = AAref;
    end
end