function plotea_eje(eje,color,LW,texti)

% PLOTEA_EJE plots 2D or 3D principal curve data on the current figure.
%
% plotea_eje(princ_curve,color_string,line_width)
%
%    princ_curve = structure with principal curve data (as given by inicializa_RN.m)
%
%    color_string = string to set line style as in plot.m
%
%    line_width = line width of the curve on the plot
%
if exist('texti')
else
    texti = 0;
end

if nargin<3 LW=0.1;end
if length(eje(1).pto) == 2

    REF = cat(1,eje.ref)';
    ind = find(REF==0);
    PTOS1 = reshape(cat(1,eje(ind(1):ind(2)-1).pto),2,length(eje(ind(1):ind(2)-1)));
    hold on,plot(PTOS1(1,:),PTOS1(2,:),color,'linewidth',LW)

    SSS = size(PTOS1,2);
    if texti ==0
    else
    for nnn = 1:SSS
        text(PTOS1(1,nnn),PTOS1(2,nnn)-0.1,num2str(REF(nnn)))
    end
    end
    
    PTOS1 = reshape(cat(1,eje(ind(2):end).pto),2,length(eje(ind(2):end)));
    hold on,plot(PTOS1(1,:),PTOS1(2,:),color,'linewidth',LW)
    
    if texti ==0
    else
    for nnn = 1:size(PTOS1,2)
        text(PTOS1(1,nnn),PTOS1(2,nnn)-0.1,[num2str(REF(nnn+SSS))])
    end
    end
    PTOS1 = reshape(cat(1,eje.pto),2,length(eje));

%     for nnn=1:length(eje)
%         fff = 1;
%         hold on,plot([PTOS1(1,nnn) PTOS1(1,nnn)+fff*eje(nnn).V_der(1,1)],[PTOS1(2,nnn) PTOS1(2,nnn)+fff*eje(nnn).V_der(2,1)],'g-','linewidth',1)
%         hold on,plot([PTOS1(1,nnn) PTOS1(1,nnn)+fff*eje(nnn).V_der(1,2)],[PTOS1(2,nnn) PTOS1(2,nnn)+fff*eje(nnn).V_der(2,2)],'c-','linewidth',1)
%     end

elseif length(eje(1).pto) == 3

    REF = cat(1,eje.ref)';
    ind=find(REF==0);

    PTOS1 = reshape(cat(1,eje(ind(1):ind(2)-1).pto),3,length(eje(ind(1):ind(2)-1)));
    hold on,plot3(PTOS1(1,:),PTOS1(2,:),PTOS1(3,:),color,'linewidth',LW)

    RR = cat(1,eje(ind(1):ind(2)-1).ref);
    SSS = size(PTOS1,2);
    
    if texti ==0
    else
    for nnn = 1:size(PTOS1,2)
        text(PTOS1(1,nnn),PTOS1(2,nnn)-0.1,PTOS1(3,nnn)-0.1,[num2str(RR(nnn))])
    end
        end

    PTOS1 = reshape(cat(1,eje(ind(2):end).pto),3,length(eje(ind(2):end)));
    hold on,plot3(PTOS1(1,:),PTOS1(2,:),PTOS1(3,:),color,'linewidth',LW)  
    
    RR = cat(1,eje(ind(2):end).ref);
    SSS = size(PTOS1,2);
    
    if texti ==0
    else
    for nnn = 1:size(PTOS1,2)
        text(PTOS1(1,nnn),PTOS1(2,nnn)-0.1,PTOS1(3,nnn)-0.1,[num2str(RR(nnn))])
    end
    end
end


