function [Po,D,delta_A,delta_A_norm]=proy_ort(pto_A,pto_B,P,pinta);

% PROY_ORT da la proyección ortogonal de un punto P sobre la recta formada
% por dos puntos A y B
% 
% USO:  [Po,D,delta_A,delta_A_norm]=proy_ort(pto_A,pto_B,P,pinta);
%
%
%     Po      = Punto proyectado
%     D       = Distancia del punto a la recta AB
%     delta_A = distancia (con signo!) entre A y Po
%               Po = A + delta_A * (B-A)/norm(B-A);
%
%     delta_A_norm = delta_A/norm(B-A);
% 

d1=P-pto_B;
d2=P-pto_A;
d3=pto_A-pto_B;

if norm(d3)==0;  % pto_A=pto_B Si el punto A y el B son el mismo, que tome la proyeccion como el pto A
    
    Po=pto_A;
    delta_A_norm=0;
    delta_A=0;
    D=sqrt(sum((P-pto_A).^2));
    
else

    norm2_d1=d1'*d1;
    norm2_d2=d2'*d2;
    norm2_d3=d3'*d3;

    delta_A=(norm2_d1-norm2_d2-norm2_d3)/(-2*sqrt(norm2_d3));

    D=sqrt(norm2_d2-delta_A^2);    % Aqui había un error: faltaba el cuadrado en delta_A -> la distancia estaba mal!!!

    Po=pto_A-delta_A*d3/norm(d3);

    if pinta==1
        figure,plot(pto_A(1),pto_A(2),'ro'),text(pto_A(1),pto_A(2),'A'),axis equal
        hold on,plot(pto_B(1),pto_B(2),'ro'),text(pto_B(1),pto_B(2),'B')
        plot([pto_A(1) pto_B(1)],[pto_A(2) pto_B(2)],'r-')
        plot(P(1),P(2),'ko'),text(P(1),P(2),'P')
        plot(Po(1),Po(2),'ko'),text(Po(1),Po(2),'P_o')
        plot([P(1) Po(1)],[P(2) Po(2)],'k-')
    end

    delta_A_norm=delta_A/norm(d3);

end