function  [pto_proximo,resp]=punto_en_eje_NLPCA(pto_buscado,eje);

% PUNTO_EN_EJE calcula cual es el punto del eje del NL-PCA más cercano al
% punto buscado y, en base a ello, calcula la respuesta correspondiente en
% esa dimensión contando el número de desplazamientos unidad realizados en
% ese eje. Además, puede dar la respuesta con una precisión más allá de la
% unidad interpolando linealmente entre cada nodo del eje NL-PCA. 
% Eso implica asumir linealidad entre cada nodo del NL-PCA. Eso no es grave
% si se toman longitudes pequeñas de los ejes locales mediante el parámetro
% \tau.
%
% USO:  [pto_proximo,resp]=punto_en_eje(pto_buscado,eje);
%
%
%     pto_buscado = vector columna
%     eje         = dimension particular del struch dado por nlpca_nd_prueba_13
%                   (eso contiene los puntos correspondientes a ese eje
%                   curvo eje.pto, el orden de dichos nodos eje.ref, y los
%                   ejes locales en cada nodo eje.A).
%                   eje=ejes(i); (siendo ejes lo que da nlpca_nd_prueba_13).
%
%

ptos = reshape(cat(1,eje(:).pto),size(pto_buscado,1),length(eje));
ref =cat(1,eje(:).ref);

d = sum((ptos-repmat(pto_buscado,1,length(ptos(1,:)))).^2);

[m,I]=min(d);

pto_B=ptos(:,I(1));

ref_B=ref(I);
if ref_B==0
    sb=1;
else
    sb=sign(ref_B);
end
ref_A=ref_B-sb;
ref_C=ref_B+sb;


if ref_A==0
    sa=1;
else
    sa=sign(ref_A);
end

if ref_C==0
    sc=1;
else
    sc=sign(ref_C);
end


II=find(ref==ref_A);
if isempty(II)    % MODIFICACION PARA QUE NO PETE PERO PUEDE DAR POR SACO!!!
   pto_A=pto_B; 
else    
   pto_A=ptos(:,II(1));
end
II=find(ref==ref_C);
if isempty(II)    % MODIFICACION PARA QUE NO PETE PERO PUEDE DAR POR SACO!!!
   pto_C=pto_B; 
else    
   pto_C=ptos(:,II(1));
end

% pto_A
% pto_B
% pto_C
% keyboard
[PoAB,DAB,delta,delta_norm_AB]=proy_ort(pto_A,pto_B,pto_buscado,0);
[PoBC,DBC,delta,delta_norm_BC]=proy_ort(pto_B,pto_C,pto_buscado,0);

% ((delta_norm_AB<0)|(delta_norm_AB>1))
% ((delta_norm_BC<0)|(delta_norm_BC>1))
% DAB
% DBC
if ((delta_norm_AB<0)|(delta_norm_AB>1))&((delta_norm_BC<0)|(delta_norm_BC>1))
    resp=ref_B;
    pto_proximo=pto_B;
        
elseif (delta_norm_AB<0)|(delta_norm_AB>1)
    resp=ref_B+delta_norm_BC*sign(sc);
    pto_proximo=PoBC;

elseif (delta_norm_BC<0)|(delta_norm_BC>1)
    resp=ref_A+delta_norm_AB*sign(sb);
    pto_proximo=PoAB;

else
    if DAB>DBC
        resp=ref_B+delta_norm_BC*sign(sc);
        pto_proximo=PoBC;

    elseif DAB<=DBC
        resp=ref_A+delta_norm_AB*sign(sb);
        pto_proximo=PoAB;
    end
end

